Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #999 (new defect)

Opened 13 years ago

Last modified 12 years ago

Transmission rate can not be set to fixed value

Reported by: jainim@gist.ac.kr Assigned to:
Priority: major Milestone: version 0.9.x - progressive release candidate phase
Component: madwifi: other Version: v0.9.2
Keywords: fixed rate Cc:
Patch is attached: 1 Pending:

Description

i configured two laptops and each of them is set ad-hoc mode. i try to fix data rate by 1Mb with "iwconfig ath0 rate 1Mb fixed" but it seems not working. using iperf, i watched almost 7Mbits/sec even the rate is fixed in 1Mb. "iwconfig ath0" shows that the rate is set 1Mb but "wlanconfig ath0 list" shows that the laptop transmits by 11Mbps.

Attachments

madwifi-0.9.2-tic999.patch (4.1 kB) - added by bhanuprakash adhikari on 08/20/07 14:19:58.
Patch to fix rate
madwifi-0.9.3.2-ticket999.patch (4.9 kB) - added by bhanuprakash adhikari on 08/28/07 13:15:54.
patch ported to 0.9.3.2
madwifi-0.9.3.2-ticket999.2.patch (5.1 kB) - added by bhanuprakash on 08/28/07 13:43:01.
<<USE THIS PATCH>> patch ported to 0.9.3.2
madwifi-0.9.3.2-ticket999.3.patch (5.0 kB) - added by bhanuprakash on 08/28/07 14:07:31.
REMOVED MINOR COMPILATION ISSUES - PATCHED ON 0.9.3.2

Change History

11/06/06 07:23:38 changed by mrenzmann

  • summary changed from fixed rate is not working in ad-hoc mode in madwifi-ng version (0.9.2) to Transmission rate can not be set to fixed value.
  • milestone set to version 0.9.x - progressive release candidate phase.

That's true also for other operation modes, as far as it has been reported by various users. I thought we already had a ticket for it, but couldn't find it on a glance. So I change the summary of this one.

That problem needs some investigation. This probably won't happen for 0.9.3, but should then be scheduled for 0.9.4.

11/27/06 05:43:30 changed by anonymous

I have also experienced this exact same issue -- has this been resolved?

11/27/06 07:22:39 changed by mrenzmann

Not yet.

12/07/06 10:33:00 changed by tjalling.hattink@ti-wmc.nl

I think this ticket is related with ticket #867, which includes a patch.

01/29/07 03:31:42 changed by anonymous

Its a small change. Basically, ath_tx_start() gets the appropriate data rate only through the rate control algorithms. To get fixed data rate, you would need to first check whether a fixed data rate has been set and then get the appropriate rate code for the data rate selected by the user. You need to add the following piece of code in ath_tx_start().

//Author: Dheeraj
case IEEE80211_FC0_TYPE_DATA:
     atype = HAL_PKT_TYPE_NORMAL;		/* default */
     if(vap->iv_fixed_rate == -1){		    		  
       ath_rate_findrate(sc, an, shortPreamble, skb->len,
			&rix, &try0, &txrate);
       try0 = ATH_TXMAXTRY;
       /* Ratecontrol sometimes returns invalid rate index */
       if (rix != 0xff)
	  an->an_prevdatarix = rix;
       else
          rix = an->an_prevdatarix;
       }
     else {
       rix = ath_tx_findindex(rt,vap->iv_fixed_rate*500);
       try0 = ATH_TXMAXTRY;
       if (shortPreamble)
          txrate = rt->info[rix].rateCode | rt->info[rix].shortPreamble;
       else
	  txrate = rt->info[rix].rateCode;
     }

08/20/07 14:19:58 changed by bhanuprakash adhikari

  • attachment madwifi-0.9.2-tic999.patch added.

Patch to fix rate

08/20/07 14:23:59 changed by bhanuprakash

This patch is built on 0.9.2. This is tested and works fine.

08/21/07 10:30:17 changed by mrenzmann

Thanks for the patch. It would be nice if you could rebuild the patch for trunk and reattach that new version. In addition it needs to be signed off before we can commit it.

08/28/07 13:15:54 changed by bhanuprakash adhikari

  • attachment madwifi-0.9.3.2-ticket999.patch added.

patch ported to 0.9.3.2

08/28/07 13:24:29 changed by bhanuprakash

The patch attached to this ticket fixes data rate to specified(using iwconfig ath0 rate 11M). This patch should be applicable to all modes including WDS.

signed-off: Bhanu Prakash Adhikari <bhanua@aztecsoft.com>

08/28/07 13:43:01 changed by bhanuprakash

  • attachment madwifi-0.9.3.2-ticket999.2.patch added.

<<USE THIS PATCH>> patch ported to 0.9.3.2

08/28/07 14:07:31 changed by bhanuprakash

  • attachment madwifi-0.9.3.2-ticket999.3.patch added.

REMOVED MINOR COMPILATION ISSUES - PATCHED ON 0.9.3.2

12/03/07 23:53:46 changed by dheeraj@cs.wisc.edu

The patch madwifi-0.9.3.2-ticket999.3.patch is incorrect I believe. When rate is set to a fixed value, the number of tries should be set to ATH_TXMAXTRY.

12/04/07 05:59:56 changed by mrenzmann

  • patch_attached set to 1.